From: Lyude <lyude@redhat.com>
To: igt-dev@lists.freedesktop.org
Subject: [igt-dev] [PATCH i-g-t 1/7] lib/tests: Fix test failures with meson 0.50.0
Date: Tue, 16 Apr 2019 16:10:55 -0400 [thread overview]
Message-ID: <20190416201101.9132-2-lyude@redhat.com> (raw)
In-Reply-To: <20190416201101.9132-1-lyude@redhat.com>
From: Lyude Paul <lyude@redhat.com>
Since meson 0.50.0, unit tests which return the GNU standard return code
99 will fail, regardless of whether or not should_fail:true is passed to
test(). Unfortunately, igt_alarm_handler() exits the application with
return code 99. However, since returning something other then 99 when a
test times out would also be a bug we can't really change the return
code igt_alarm_handler() returns.
Instead, we can fix this by simply running tests which are expected to
fail with return code 99 using a wrapper script that translates 99 to 1
and any other non-zero error code into 99. This essentially makes it so
that abnormal test failures are considered normal, and vice versa.
Signed-off-by: Lyude Paul <lyude@redhat.com>
---
lib/tests/meson.build | 15 +++++++++++++++
lib/tests/retcode_99_wrapper.sh | 11 +++++++++++
2 files changed, 26 insertions(+)
create mode 100644 lib/tests/retcode_99_wrapper.sh
diff --git a/lib/tests/meson.build b/lib/tests/meson.build
index 74efce39..108597cf 100644
--- a/lib/tests/meson.build
+++ b/lib/tests/meson.build
@@ -18,6 +18,9 @@ lib_tests = [
lib_fail_tests = [
'igt_no_subtest',
'igt_simple_test_subtests',
+]
+
+lib_retcode_99_tests = [
'igt_timeout',
]
@@ -32,3 +35,15 @@ foreach lib_test : lib_fail_tests
dependencies : igt_deps)
test('lib: ' + lib_test, exec, should_fail : true)
endforeach
+
+# Some tests are expected to fail with a retcode of 99. Since meson 0.50.0, unit
+# tests that return this error code are marked as failures regardless of the
+# value of should_fail. So, we run these tests in a wrapper to translate return
+# codes of 99 into 1, and non-zero error codes into 99 (so normal failures are
+# counted as abnormal failures)
+wrapper_99 = find_program('retcode_99_wrapper.sh')
+foreach lib_test : lib_retcode_99_tests
+ exec = executable(lib_test, lib_test + '.c', install : false,
+ dependencies : igt_deps)
+ test('lib: ' + lib_test, wrapper_99, args : [exec], should_fail : true)
+endforeach
diff --git a/lib/tests/retcode_99_wrapper.sh b/lib/tests/retcode_99_wrapper.sh
new file mode 100644
index 00000000..cfd8825d
--- /dev/null
+++ b/lib/tests/retcode_99_wrapper.sh
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+"$@"
+last_ret="$?"
+if [ $last_ret -eq 99 ]; then
+ exit 1
+elif [ $last_ret -ne 0 ]; then
+ exit 99 # We expected to fail with 99, normal failures are abnormal
+else
+ exit $last_ret
+fi
--
2.20.1
_______________________________________________
igt-dev mailing list
igt-dev@lists.freedesktop.org
https://lists.freedesktop.org/mailman/listinfo/igt-dev
next prev parent reply other threads:[~2019-04-16 20:11 UTC|newest]
Thread overview: 18+ messages / expand[flat|nested] mbox.gz Atom feed top
2019-04-16 20:10 [igt-dev] [PATCH i-g-t 0/7] Fixes from updating igt packaging in Fedora Lyude
2019-04-16 20:10 ` Lyude [this message]
2019-04-17 8:29 ` [igt-dev] [PATCH i-g-t 1/7] lib/tests: Fix test failures with meson 0.50.0 Petri Latvala
2019-04-16 20:10 ` [igt-dev] [PATCH i-g-t 2/7] meson: Don't redefine gettid if the C library provides it Lyude
2019-04-17 8:37 ` Petri Latvala
2019-04-16 20:10 ` [igt-dev] [PATCH i-g-t 3/7] lib: Stop using assert() for runtime checks Lyude
2019-04-17 8:52 ` Petri Latvala
2019-04-24 0:36 ` Lyude Paul
2019-04-24 10:13 ` Petri Latvala
2019-04-16 20:10 ` [igt-dev] [PATCH i-g-t 4/7] lib/igt_core: Just use igt_can_fail() in __igt_run_subtest() Lyude
2019-04-17 9:05 ` Petri Latvala
2019-04-16 20:10 ` [igt-dev] [PATCH i-g-t 5/7] Use pkgconfig() macros with dnf in Fedora Dockerfile Lyude
2019-04-17 9:09 ` Petri Latvala
2019-04-24 17:18 ` Lyude Paul
2019-04-16 20:11 ` [igt-dev] [PATCH i-g-t 6/7] Update Dockerfile.fedora to Fedora 29 Lyude
2019-04-16 20:11 ` [igt-dev] [PATCH i-g-t 7/7] Gitlab CI: Do builds with -Db_ndebug=true Lyude
2019-04-16 20:44 ` [igt-dev] ✓ Fi.CI.BAT: success for Fixes from updating igt packaging in Fedora Patchwork
2019-04-17 6:04 ` [igt-dev] ✓ Fi.CI.IGT: " Patchwork
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20190416201101.9132-2-lyude@redhat.com \
--to=lyude@redhat.com \
--cc=igt-dev@lists.freedesktop.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox